<?php
class ControllerExtensionModuleocarouselthree extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/ocarouselthree');

		$this->document->setTitle(preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')));

		$this->load->model('extension/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_extension_module->addModule('ocarouselthree', $this->request->post);
			} else {
				$this->model_extension_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
		}

		$data['heading_title'] = preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title'));

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_cwkj_wxts'] = $this->language->get('text_cwkj_wxts');
		$data['text_qq_open_signup'] = $this->language->get('text_qq_open_signup');
		$data['text_yes'] = $this->language->get('text_yes');
		$data['text_no'] = $this->language->get('text_no');
		
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_name'] = $this->language->get('entry_name');
        $data['entry_sectiontab'] = $this->language->get('entry_sectiontab');	
		$data['entry_titlename'] = $this->language->get('entry_titlename');
		$data['entry_describe'] = $this->language->get('entry_describe');
		$data['entry_zdybj'] = $this->language->get('entry_zdybj');
		$data['entry_octrgba'] = $this->language->get('entry_octrgba');
		$data['entry_bgcolortitle'] = $this->language->get('entry_bgcolortitle');
		$data['entry_bgcolor'] = $this->language->get('entry_bgcolor');
		$data['entry_bgcolorcss'] = $this->language->get('entry_bgcolorcss');
		$data['entry_titlejbcss'] = $this->language->get('entry_titlejbcss');
		$data['entry_titlecss'] = $this->language->get('entry_titlecss');
		$data['entry_titlecsstwo'] = $this->language->get('entry_titlecsstwo');
		$data['entry_bordercss'] = $this->language->get('entry_bordercss');
		$data['entry_image'] = $this->language->get('entry_image');
		$data['entry_images'] = $this->language->get('entry_images');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_link'] = $this->language->get('entry_link');
		$data['entry_link1'] = $this->language->get('entry_link1');
		$data['entry_link2'] = $this->language->get('entry_link2');
		$data['entry_image'] = $this->language->get('entry_image');
		$data['entry_imagepicstyle'] = $this->language->get('entry_imagepicstyle');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_buttoncolorcss'] = $this->language->get('entry_buttoncolorcss');
		$data['entry_buttoncss'] = $this->language->get('entry_buttoncss');
		$data['entry_buttonbjcss'] = $this->language->get('entry_buttonbjcss');
		$data['entry_buttontitcss'] = $this->language->get('entry_buttontitcss');
		$data['entry_buttontithover'] = $this->language->get('entry_buttontithover');
		$data['entry_buttonradius'] = $this->language->get('entry_buttonradius');
		$data['entry_autoplay'] = $this->language->get('entry_autoplay');
		$data['entry_speed'] = $this->language->get('entry_speed');
		$data['entry_fade'] = $this->language->get('entry_fade');
		$data['entry_wgdlg'] = $this->language->get('entry_wgdlg');
		$data['help_wgdlg'] = $this->language->get('help_wgdlg');
		$data['entry_wgdlg1'] = $this->language->get('entry_wgdlg1');
		$data['entry_wgdlg2'] = $this->language->get('entry_wgdlg2');
		$data['entry_dpl'] = $this->language->get('entry_dpl');
		$data['help_dpl'] = $this->language->get('help_dpl');
		$data['entry_section2'] = $this->language->get('entry_section2');
		$data['entry_button1'] = $this->language->get('entry_button1');
		$data['entry_button2'] = $this->language->get('entry_button2');
		$data['entry_buttonname1'] = $this->language->get('entry_buttonname1');
		$data['entry_buttonname2'] = $this->language->get('entry_buttonname2');
		$data['entry_qq1'] = $this->language->get('entry_qq1');
		$data['entry_qq2'] = $this->language->get('entry_qq2');
		$data['entry_alww1'] = $this->language->get('entry_alww1');
		$data['entry_alww2'] = $this->language->get('entry_alww2');
		$data['entry_link1'] = $this->language->get('entry_link1');
		$data['entry_link2'] = $this->language->get('entry_link2');
		$data['entry_icons1'] = $this->language->get('entry_icons1');
		$data['entry_icons2'] = $this->language->get('entry_icons2');
		$data['entry_buttoncolor1'] = $this->language->get('entry_buttoncolor1');
		$data['entry_buttoncolor2'] = $this->language->get('entry_buttoncolor2');
		$data['entry_buttonstyle'] = $this->language->get('entry_buttonstyle');
		$data['entry_buttonsize'] = $this->language->get('entry_buttonsize');
		$data['entry_buttoninset'] = $this->language->get('entry_buttoninset');
		$data['entry_buttonborder'] = $this->language->get('entry_buttonborder');
		$data['entry_buttonround'] = $this->language->get('entry_buttonround');
		$data['entry_buttonhover'] = $this->language->get('entry_buttonhover');
        $data['entry_buttond'] = $this->language->get('entry_buttond');	
		$data['entry_topmagin'] = $this->language->get('entry_topmagin');
		$data['entry_btmagin'] = $this->language->get('entry_btmagin');
		$data['entry_maxwidth'] = $this->language->get('entry_maxwidth');
		$data['entry_imagewidth'] = $this->language->get('entry_imagewidth');
        $data['entry_imageheight'] = $this->language->get('entry_imageheight');	
		$data['entry_ocbwposition'] = $this->language->get('entry_ocbwposition');
		$data['entry_bannerbgc'] = $this->language->get('entry_bannerbgc');
		$data['entry_bannerbgcjb'] = $this->language->get('entry_bannerbgcjb');
		$data['entry_titleposition'] = $this->language->get('entry_titleposition');
		$data['entry_titlefontsize'] = $this->language->get('entry_titlefontsize');
		$data['entry_msonefontsize'] = $this->language->get('entry_msonefontsize');
		$data['entry_mstwofontsize'] = $this->language->get('entry_mstwofontsize');
		$data['entry_imganimation'] = $this->language->get('entry_imganimation');
		
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		$data['button_add'] = $this->language->get('button_add');
		$data['button_remove'] = $this->language->get('button_remove');

		$data['error_name'] = $this->language->get('error_name');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}
		if (isset($this->error['image'])) {
			$data['error_image'] = $this->error['image'];
		} else {
			$data['error_image'] = '';
		}

		if (isset($this->error['width'])) {
			$data['error_width'] = $this->error['width'];
		} else {
			$data['error_width'] = '';
		}
		if (isset($this->error['imagewidth'])) {
			$data['error_imagewidth'] = $this->error['imagewidth'];
		} else {
			$data['error_imagewidth'] = '';
		}
		if (isset($this->error['imageheight'])) {
			$data['error_imageheight'] = $this->error['imageheight'];
		} else {
			$data['error_imageheight'] = '';
		}
		if (isset($this->error['dpl'])) {
			$data['error_dpl'] = $this->error['dpl'];
		} else {
			$data['error_dpl'] = '';
		}
		if (isset($this->error['height'])) {
			$data['error_height'] = $this->error['height'];
		} else {
			$data['error_height'] = '';
		}
		if (isset($this->error['wgdlg1'])) {
			$data['error_wgdlg1'] = $this->error['wgdlg1'];
		} else {
			$data['error_wgdlg1'] = '';
		}
		if (isset($this->error['wgdlg2'])) {
			$data['error_wgdlg2'] = $this->error['wgdlg2'];
		} else {
			$data['error_wgdlg2'] = '';
		}
		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_module'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => preg_replace('/<(.*?)strong>/i', '', $this->language->get('heading_title')),
			'href' => $this->url->link('extension/module/ocarouselthree', 'token=' . $this->session->data['token'], 'SSL')
		);

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('extension/module/ocarouselthree', 'token=' . $this->session->data['token'], 'SSL');
		} else {
			$data['action'] = $this->url->link('extension/module/ocarouselthree', 'token=' . $this->session->data['token'] . '&module_id=' . $this->request->get['module_id'], 'SSL');
		}

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true);

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_extension_module->getModule($this->request->get['module_id']);
		}

		$data['token'] = $this->session->data['token'];

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}
		if (isset($this->request->post['sectiontab'])) {
			$data['sectiontab'] = $this->request->post['sectiontab'];
		} elseif (!empty($module_info)) {
			$data['sectiontab'] = $module_info['sectiontab'];
		} else {
			$data['sectiontab'] = '';
		}
		if (isset($this->request->post['titlename'])) {
			$data['titlename'] = $this->request->post['titlename'];
		} elseif (!empty($module_info)) {
			$data['titlename'] = $module_info['titlename'];
		} else {
			$data['titlename'] = '';
		}
		if (isset($this->request->post['describe'])) {
			$data['describe'] = $this->request->post['describe'];
		} elseif (!empty($module_info)) {
			$data['describe'] = $module_info['describe'];
		} else {
			$data['describe'] = '';
		}
		$this->load->model('tool/image');

		if (isset($this->request->post['image'])) {
			$data['image'] = $this->request->post['image'];
		} elseif (isset($module_info['image'])) {
			$data['image'] = $module_info['image'];
		} else {
			$data['image'] = '';
		}

		if (is_file(DIR_IMAGE . $data['image'])) {
			$thumb = $data['image'];
		} else {
			$thumb = 'no_image.png';
		}

		$data['thumb'] = $this->model_tool_image->resize($thumb, 100, 100);

		if (isset($this->request->post['width'])) {
			$data['width'] = $this->request->post['width'];
		} elseif (!empty($module_info)) {
			$data['width'] = $module_info['width'];
		} else {
			$data['width'] = '1600';
		}

		if (isset($this->request->post['height'])) {
			$data['height'] = $this->request->post['height'];
		} elseif (!empty($module_info)) {
			$data['height'] = $module_info['height'];
		} else {
			$data['height'] = '750';
		}
		if (isset($this->request->post['bgcolorcss'])) {
			$data['bgcolorcss'] = $this->request->post['bgcolorcss'];
		} elseif (!empty($module_info)) {
			$data['bgcolorcss'] = $module_info['bgcolorcss'];
		} else {
			$data['bgcolorcss'] = '';
		}
		if (isset($this->request->post['titlecss'])) {
			$data['titlecss'] = $this->request->post['titlecss'];
		} elseif (!empty($module_info)) {
			$data['titlecss'] = $module_info['titlecss'];
		} else {
			$data['titlecss'] = '';
		}
		if (isset($this->request->post['titlecsstwo'])) {
			$data['titlecsstwo'] = $this->request->post['titlecsstwo'];
		} elseif (!empty($module_info)) {
			$data['titlecsstwo'] = $module_info['titlecsstwo'];
		} else {
			$data['titlecsstwo'] = '';
		}
		if (isset($this->request->post['octrgba'])) {
			$data['octrgba'] = $this->request->post['octrgba'];
		} elseif (!empty($module_info)) {
			$data['octrgba'] = $module_info['octrgba'];
		} else {
			$data['octrgba'] = 'rgba(0,0,0,0.5)';
		}
		if (isset($this->request->post['bannerbgc'])) {
			$data['bannerbgc'] = $this->request->post['bannerbgc'];
		} elseif (!empty($module_info)) {
			$data['bannerbgc'] = $module_info['bannerbgc'];
		} else {
			$data['bannerbgc'] = '';
		}
		if (isset($this->request->post['bannerbgcjb'])) {
			$data['bannerbgcjb'] = $this->request->post['bannerbgcjb'];
		} elseif (!empty($module_info)) {
			$data['bannerbgcjb'] = $module_info['bannerbgcjb'];
		} else {
			$data['bannerbgcjb'] = '';
		}	
		if (isset($this->request->post['buttoncss'])) {
			$data['buttoncss'] = $this->request->post['buttoncss'];
		} elseif (!empty($module_info)) {
			$data['buttoncss'] = $module_info['buttoncss'];
		} else {
			$data['buttoncss'] = '';
		}
		if (isset($this->request->post['buttonbjcss'])) {
			$data['buttonbjcss'] = $this->request->post['buttonbjcss'];
		} elseif (!empty($module_info)) {
			$data['buttonbjcss'] = $module_info['buttonbjcss'];
		} else {
			$data['buttonbjcss'] = '';
		}
		if (isset($this->request->post['buttontitcss'])) {
			$data['buttontitcss'] = $this->request->post['buttontitcss'];
		} elseif (!empty($module_info)) {
			$data['buttontitcss'] = $module_info['buttontitcss'];
		} else {
			$data['buttontitcss'] = '';
		}
		if (isset($this->request->post['buttontithover'])) {
			$data['buttontithover'] = $this->request->post['buttontithover'];
		} elseif (!empty($module_info)) {
			$data['buttontithover'] = $module_info['buttontithover'];
		} else {
			$data['buttontithover'] = '';
		}	
		if (isset($this->request->post['buttonradius'])) {
			$data['buttonradius'] = $this->request->post['buttonradius'];
		} elseif (!empty($module_info)) {
			$data['buttonradius'] = $module_info['buttonradius'];
		} else {
			$data['buttonradius'] = '';
		}
		if (isset($this->request->post['mstwofontsize'])) {
			$data['mstwofontsize'] = $this->request->post['mstwofontsize'];
		} elseif (!empty($module_info)) {
			$data['mstwofontsize'] = $module_info['mstwofontsize'];
		} else {
			$data['mstwofontsize'] = '';
		}	
		if (isset($this->request->post['msonefontsize'])) {
			$data['msonefontsize'] = $this->request->post['msonefontsize'];
		} elseif (!empty($module_info)) {
			$data['msonefontsize'] = $module_info['msonefontsize'];
		} else {
			$data['msonefontsize'] = '';
		}
		if (isset($this->request->post['autoplay'])) {
			$data['autoplay'] = $this->request->post['autoplay'];
		} elseif (!empty($module_info)) {
			$data['autoplay'] = $module_info['autoplay'];
		} else {
			$data['autoplay'] = '';
		}
		if (isset($this->request->post['speed'])) {
			$data['speed'] = $this->request->post['speed'];
		} elseif (!empty($module_info)) {
			$data['speed'] = $module_info['speed'];
		} else {
			$data['speed'] = '3000';
		} 
		if (isset($this->request->post['fade'])) {
			$data['fade'] = $this->request->post['fade'];
		} elseif (!empty($module_info)) {
			$data['fade'] = $module_info['fade'];
		} else {
			$data['fade'] = '';
		}
		if (isset($this->request->post['dpl'])) {
			$data['dpl'] = $this->request->post['dpl'];
		} elseif (!empty($module_info)) {
			$data['dpl'] = $module_info['dpl'];
		} else {
			$data['dpl'] = 'left';
		}
		if (isset($this->request->post['wgdlg1'])) {
			$data['wgdlg1'] = $this->request->post['wgdlg1'];
		} elseif (!empty($module_info)) {
			$data['wgdlg1'] = $module_info['wgdlg1'];
		} else {
			$data['wgdlg1'] = '6';
		}
		if (isset($this->request->post['wgdlg2'])) {
			$data['wgdlg2'] = $this->request->post['wgdlg2'];
		} elseif (!empty($module_info)) {
			$data['wgdlg2'] = $module_info['wgdlg2'];
		} else {
			$data['wgdlg2'] = '6';
		}
		if (isset($this->request->post['section2'])) {
			$data['section2'] = $this->request->post['section2'];
		} elseif (!empty($module_info)) {
			$data['section2'] = $module_info['section2'];
		} else {
			$data['section2'] = '';
		}
		if (isset($this->request->post['buttonname1'])) {
			$data['buttonname1'] = $this->request->post['buttonname1'];
		} elseif (!empty($module_info)) {
			$data['buttonname1'] = $module_info['buttonname1'];
		} else {
			$data['buttonname1'] = '';
		}
		if (isset($this->request->post['buttonname2'])) {
			$data['buttonname2'] = $this->request->post['buttonname2'];
		} elseif (!empty($module_info)) {
			$data['buttonname2'] = $module_info['buttonname2'];
		} else {
			$data['buttonname2'] = '';
		}
		if (isset($this->request->post['qq1'])) {
			$data['qq1'] = $this->request->post['qq1'];
		} elseif (!empty($module_info)) {
			$data['qq1'] = $module_info['qq1'];
		} else {
			$data['qq1'] = '';
		}
		if (isset($this->request->post['qq2'])) {
			$data['qq2'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['qq2'] = $module_info['qq2'];
		} else {
			$data['qq2'] = '';
		}
		if (isset($this->request->post['alww1'])) {
			$data['alww1'] = $this->request->post['alww1'];
		} elseif (!empty($module_info)) {
			$data['alww1'] = $module_info['alww1'];
		} else {
			$data['alww1'] = '';
		}
		if (isset($this->request->post['alww2'])) {
			$data['alww2'] = $this->request->post['alww2'];
		} elseif (!empty($module_info)) {
			$data['alww2'] = $module_info['alww2'];
		} else {
			$data['alww2'] = '';
		}
		if (isset($this->request->post['link1'])) {
			$data['link1'] = $this->request->post['link1'];
		} elseif (!empty($module_info)) {
			$data['link1'] = $module_info['link1'];
		} else {
			$data['link1'] = '';
		}
		if (isset($this->request->post['link2'])) {
			$data['link2'] = $this->request->post['link2'];
		} elseif (!empty($module_info)) {
			$data['link2'] = $module_info['link2'];
		} else {
			$data['link2'] = '';
		}
		if (isset($this->request->post['icons1'])) {
			$data['icons1'] = $this->request->post['icons1'];
		} elseif (!empty($module_info)) {
			$data['icons1'] = $module_info['icons1'];
		} else {
			$data['icons1'] = 'fa fa-apple';
		}
		if (isset($this->request->post['icons2'])) {
			$data['icons2'] = $this->request->post['icons2'];
		} elseif (!empty($module_info)) {
			$data['icons2'] = $module_info['icons2'];
		} else {
			$data['icons2'] = 'fa fa-android';
		}
		if (isset($this->request->post['buttoncolor1'])) {
			$data['buttoncolor1'] = $this->request->post['buttoncolor1'];
		} elseif (!empty($module_info)) {
			$data['buttoncolor1'] = $module_info['buttoncolor1'];
		} else {
			$data['buttoncolor1'] = 'white';
		}
		if (isset($this->request->post['buttoncolor2'])) {
			$data['buttoncolor2'] = $this->request->post['buttoncolor2'];
		} elseif (!empty($module_info)) {
			$data['buttoncolor2'] = $module_info['buttoncolor2'];
		} else {
			$data['buttoncolor2'] = 'white';
		}
		if (isset($this->request->post['buttonsize'])) {
			$data['buttonsize'] = $this->request->post['buttonsize'];
		} elseif (!empty($module_info)) {
			$data['buttonsize'] = $module_info['buttonsize'];
		} else {
			$data['buttonsize'] = 'md';
		}		
		if (isset($this->request->post['buttoninset'])) {
			$data['buttoninset'] = $this->request->post['buttoninset'];
		} elseif (!empty($module_info)) {
			$data['buttoninset'] = $module_info['buttoninset'];
		} else {
			$data['buttoninset'] = '';
		}	
		if (isset($this->request->post['buttonborder'])) {
			$data['buttonborder'] = $this->request->post['buttonborder'];
		} elseif (!empty($module_info)) {
			$data['buttonborder'] = $module_info['buttonborder'];
		} else {
			$data['buttonborder'] = '';
		}		
		if (isset($this->request->post['buttonround'])) {
			$data['buttonround'] = $this->request->post['buttonround'];
		} elseif (!empty($module_info)) {
			$data['buttonround'] = $module_info['buttonround'];
		} else {
			$data['buttonround'] = '';
		}
		if (isset($this->request->post['buttonhover'])) {
			$data['buttonhover'] = $this->request->post['buttonhover'];
		} elseif (!empty($module_info)) {
			$data['buttonhover'] = $module_info['buttonhover'];
		} else {
			$data['buttonhover'] = '';
		}
		if (isset($this->request->post['buttond'])) {
			$data['buttond'] = $this->request->post['buttond'];
		} elseif (!empty($module_info)) {
			$data['buttond'] = $module_info['buttond'];
		} else {
			$data['buttond'] = '';
		}
		if (isset($this->request->post['topmagin'])) {
			$data['topmagin'] = $this->request->post['topmagin'];
		} elseif (!empty($module_info)) {
			$data['topmagin'] = $module_info['topmagin'];
		} else {
			$data['topmagin'] = '120';
		}		
		if (isset($this->request->post['btmagin'])) {
			$data['btmagin'] = $this->request->post['btmagin'];
		} elseif (!empty($module_info)) {
			$data['btmagin'] = $module_info['btmagin'];
		} else {
			$data['btmagin'] = '120';
		}
		if (isset($this->request->post['maxwidth'])) {
			$data['maxwidth'] = $this->request->post['maxwidth'];
		} elseif (!empty($module_info)) {
			$data['maxwidth'] = $module_info['maxwidth'];
		} else {
			$data['maxwidth'] = '';
		}
		if (isset($this->request->post['imagewidth'])) {
			$data['imagewidth'] = $this->request->post['imagewidth'];
		} elseif (!empty($module_info)) {
			$data['imagewidth'] = $module_info['imagewidth'];
		} else {
			$data['imagewidth'] = '320';
		}
		if (isset($this->request->post['imageheight'])) {
			$data['imageheight'] = $this->request->post['imageheight'];
		} elseif (!empty($module_info)) {
			$data['imageheight'] = $module_info['imageheight'];
		} else {
			$data['imageheight'] = '320';
		}
		if (isset($this->request->post['titleposition'])) {
			$data['titleposition'] = $this->request->post['titleposition'];
		} elseif (!empty($module_info)) {
			$data['titleposition'] = $module_info['titleposition'];
		} else {
			$data['titleposition'] = '';
		}
		if (isset($this->request->post['titlefontsize'])) {
			$data['titlefontsize'] = $this->request->post['titlefontsize'];
		} elseif (!empty($module_info)) {
			$data['titlefontsize'] = $module_info['titlefontsize'];
		} else {
			$data['titlefontsize'] = '';
		}
		if (isset($this->request->post['imagepicstyle'])) {
			$data['imagepicstyle'] = $this->request->post['imagepicstyle'];
		} elseif (!empty($module_info)) {
			$data['imagepicstyle'] = $module_info['imagepicstyle'];
		} else {
			$data['imagepicstyle'] = '';
		}
		if (isset($this->request->post['imganimation'])) {
			$data['imganimation'] = $this->request->post['imganimation'];
		} elseif (!empty($module_info)) {
			$data['imganimation'] = $module_info['imganimation'];
		} else {
			$data['imganimation'] = '';
		}		
		$this->load->model('tool/image');

		if (isset($this->request->post['image'])) {
			$data['image'] = $this->request->post['image'];
		} elseif (isset($module_info['image'])) {
			$data['image'] = $module_info['image'];
		} else {
			$data['image'] = '';
		}

		if (is_file(DIR_IMAGE . $data['image'])) {
			$thumb = $data['image'];
		} else {
			$thumb = 'no_image.png';
		}

		$data['thumb'] = $this->model_tool_image->resize($thumb, 100, 100);

		$this->load->model('localisation/language');

		$data['languages'] = $this->model_localisation_language->getLanguages();

		$this->load->model('tool/image');

		if (isset($this->request->post['service'])) {
			$services = $this->request->post['service'];
		} elseif (isset($module_info['service'])) {
			$services = $module_info['service'];
		} else {
			$services = array();
		}

		$data['services'] = array();

		foreach ($services as $service) {
			if (is_file(DIR_IMAGE . $service['image'])) {
				$image = $service['image'];
				$thumb = $service['image'];
			} else {
				$image = '';
				$thumb = 'no_image.png';
			}

			$data['services'][] = array(
				'link1'        => $service['link1'],
				'image'       => $image,
				'thumb'       => $this->model_tool_image->resize($thumb, 100, 100),
				'sort_order'  => $service['sort_order']
			);
		}

		$data['placeholder'] = $this->model_tool_image->resize('no_image.png', 100, 100);

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/ocarouselthree.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/ocarouselthree')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 2) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}
		if (!$this->request->post['image']) {
			$this->error['image'] = $this->language->get('error_image');
		}

		if (!$this->request->post['width']) {
			$this->error['width'] = $this->language->get('error_width');
		}

		if (!$this->request->post['height']) {
			$this->error['height'] = $this->language->get('error_height');
		}
		if (!$this->request->post['imagewidth']) {
			$this->error['imagewidth'] = $this->language->get('error_imagewidth');
		}
		if (!$this->request->post['imageheight']) {
			$this->error['imageheight'] = $this->language->get('error_imageheight');
		}		
		if ((utf8_strlen($this->request->post['wgdlg1']) < 1) || (utf8_strlen($this->request->post['wgdlg1']) > 64)) {
			$this->error['wgdlg1'] = $this->language->get('error_wgdlg1');
		}
		if ((utf8_strlen($this->request->post['wgdlg2']) < 1) || (utf8_strlen($this->request->post['wgdlg2']) > 64)) {
			$this->error['wgdlg2'] = $this->language->get('error_wgdlg2');
		}
		if ((utf8_strlen($this->request->post['dpl']) < 1) || (utf8_strlen($this->request->post['dpl']) > 64)) {
			$this->error['dpl'] = $this->language->get('error_dpl');
		}
		return !$this->error;
	}
}